function nd() {
    var newNode = Y.Node.create('<div/>');
    for (var i=0, len=arguments.length; i<len; i++) {
        newNode.addClass(arguments[i]);
    }
    return newNode;
}

function nul() {
    var newNode = Y.Node.create('<ul/>');
    for (var i=0, len=arguments.length; i<len; i++) {
        newNode.addClass(arguments[i]);
    }
    return newNode;
}

function nli() {
    var newNode = Y.Node.create('<li/>');
    for (var i=0, len=arguments.length; i<len; i++) {
        newNode.addClass(arguments[i]);
    }
    return newNode;
}

var dummyTest = {
    board_class: "&nbsp;",
    result: 'none',
    passes: 0,
    fails: 0,
    pass_delta: null,
    fail_delta: null
};
var dummyBuild = {config: "&nbsp;", result: 'none', tests:[]};

function hideCells(e, parentSelector) {
    var cls = e.target.get('value');
    var checked = e.target.get('checked');
    if (checked) {
        Y.all(cls).removeClass('hidden');
    } else {
        Y.all(cls).addClass('hidden');
    }
    Y.all(parentSelector).each(
        function (n) {
            var visible = n.all('> .cell:not(.dummy):not(.hidden)');
            var s = visible.size();
            visible.setStyle('width', (100.0 - s + 1)/s + '%');
        }
    );
    Y.all('.item-inner.day').each(
        function (n) {
            var p = n.ancestor('li.day');
            var day = {};
            day.date = Y.Lang.trim(n.getContent().slice(0, n.getContent().indexOf('–')));
            day.tree_count = p.all('.cell.tree:not(.dummy):not(.hidden)').size();
            day.build_count = p.all('.cell.tree:not(.dummy):not(.hidden) .cell.build:not(.dummy):not(.hidden)').size();
            day.test_count = p.all('.cell.tree:not(.dummy):not(.hidden) .cell.build:not(.dummy):not(.hidden) .cell.test:not(.dummy):not(.hidden)').size();
            n.setContent(dayText(day));
        }
    );
}

function renderIntoWith(parent, callable, arr, balance, dummyData) {
    var w = (100.0 - arr.length + 1)/arr.length;
    var children = arr.map(function (elem) { return callable(elem, arr.length); });
    if (dummyData) {
        children.unshift(callable(dummyData, 0));
        children[0].addClass('dummy');
    }
    for (var i = 0; i < children.length; i++) {
        if (balance) {
            children[i].addClass('cell');
            if (!children[i].hasClass('dummy')) {
                children[i].setStyle('width', w + '%');
            }
        }
        parent.appendChild(children[i]);
    }
}

function showList (e, test_list) {
    e.preventDefault();
    Y.log(test_list);
}

function renderTest (test) {
    var r = nli('test', 'test-' + test.board_class, 'result', 'result-' + test.result);
    var outer = nd('item', 'test', 'test-' + test.board_class, 'result', 'result-' + test.result);
    var inner = nd('item-inner', 'test', 'test-' + test.board_class, 'result', 'result-' + test.result);
    outer.appendChild(inner);
    // if (test.fail_delta !== null && test.pass_delta !== null) {
    //     var delta = nd().setStyle('float', 'right');
    //     var fail_delta_str, fail_cls='', fail_title;
    //     if (test.fail_delta > 0) {
    //         fail_delta_str = '+' + test.fail_delta;
    //         fail_title = test.fail_delta + ' more tests failed than in the last run';
    //         fail_cls = 'more-fails';
    //     } else if (test.fail_delta < 0) {
    //         fail_delta_str = '' + test.fail_delta;
    //         fail_title = -test.fail_delta + ' fewer tests failed than in the last run';
    //         fail_cls = 'fewer-fails';
    //     } else {
    //         fail_delta_str = '&plusmn;' + test.fail_delta;
    //         fail_cls = 'same-fails';
    //         fail_title = 'The same number of tests failed as in the last run';
    //     }
    //     var pass_delta_str, pass_cls='', pass_title;
    //     if (test.pass_delta > 0) {
    //         pass_delta_str = '+' + test.pass_delta;
    //         pass_title = test.pass_delta + ' more tests passed than in the last run';
    //         pass_cls = 'more-passes';
    //     } else if (test.pass_delta < 0) {
    //         pass_delta_str = '' + test.pass_delta;
    //         pass_cls = 'fewer-passes';
    //         pass_title = -test.pass_delta + ' fewer tests passed than in the last run';
    //     } else {
    //         pass_delta_str = '&plusmn;' + test.pass_delta;
    //         pass_cls = 'same-passes';
    //         pass_title = 'The same number of tests passed as in the last run';
    //     }
    //     delta.appendChild(
    //         Y.Node.create('<abbr />')
    //             .addClass('pass-delta').addClass(pass_cls)
    //             .setAttribute('title', pass_title)
    //             .setContent(pass_delta_str));
    //     delta.appendChild('&nbsp;');
    //     delta.appendChild(
    //         Y.Node.create('<abbr />')
    //             .addClass('fail-delta').addClass(fail_cls)
    //             .setAttribute('title', fail_title)
    //             .setContent(fail_delta_str));
    //     inner.appendChild(delta);
    // }
    inner.appendChild('Test&nbsp;on');
    inner.appendChild('<br />');
    inner.appendChild(
        Y.Node.create('<a>').setAttribute(
            'href', link_prefix + test.sha1).setContent(test.board_class));
    if (test.board_class != '&nbsp;') {
        inner.appendChild('<br />');
        if (test.pass_to_fail.length) {
            var a = Y.Node.create('<a href="#"/>');
            a.setContent(test.pass_to_fail.length+'&nbsp;new fails');
            a.on('click', showList, undefined, test.pass_to_fail);
            inner.appendChild(a);
        } else {
            inner.appendChild('&nbsp;');
        }
        inner.appendChild('<br />');
        if (test.fail_to_pass.length) {
            var a = Y.Node.create('<a href="#"/>');
            a.setContent(test.fail_to_pass.length+'&nbsp;new passes');
            a.on('click', showList, undefined, test.fail_to_pass);
            inner.appendChild(a);
        } else {
            inner.appendChild('&nbsp;');
        }
    } else {
        inner.appendChild('<br />');
        inner.appendChild('&nbsp;');
        inner.appendChild('<br />');
        inner.appendChild('&nbsp;');
    }
    outer.setAttribute('id', 'sha1-' + test.sha1);
    r.appendChild(outer);
    return r;
}

function renderBuild (build) {
    var r = nli('build', 'build-' + build.config, 'result', 'result-' + build.result);
    var ul = nul('container', 'tests');
    renderIntoWith(ul, renderTest, build.tests, true, dummyTest);
    r.appendChild(ul);
    var outer = nd('item', 'build', 'build-' + build.config, 'result', 'result-' + build.result);
    var inner = nd('item-inner', 'build', 'build-' + build.config, 'result', 'result-' + build.result);
    outer.appendChild(inner);
    inner.appendChild('Build&nbsp;of');
    inner.appendChild('<br/>');
    inner.appendChild(
        Y.Node.create('<a>').setAttribute(
            'href', link_prefix + build.sha1).setContent(build.config));
    outer.setAttribute('id', 'sha1-' + build.sha1);
    r.appendChild(outer);
    return r;
}

function renderCommit (commit) {
    var r = nli('commit');
    var ul = nul('container', 'builds');
    renderIntoWith(ul, renderBuild, commit.builds, true, dummyBuild);
    r.appendChild(ul);
    var outer = nd('item', 'commit');
    var inner = nd('item-inner', 'commit');
    inner.appendChild(commit.describe);
    inner.setAttribute('title', commit.sha1);
    outer.appendChild(inner);
    r.appendChild(outer);
    return r;
}

function renderTree (tree, nTrees) {
    var r = nli('tree', 'tree-' + tree.index);
    var treeNode;
    if (nTrees > 2) {
        treeNode = nd('item', 'tree', 'tree-expander');
        treeNode.appendChild('<span class="arrow in-arrow invisible">&rarr;</span>');
        treeNode.appendChild('<span class="arrow out-arrow invisible">&larr;</span>');
        treeNode.appendChild(tree.name);
        treeNode.appendChild('<span class="arrow out-arrow invisible">&rarr;</span>');
        treeNode.appendChild('<span class="arrow in-arrow invisible">&larr;</span>');
    } else {
        treeNode = nd('item', 'tree');
        treeNode.setContent(tree.name);
    }
    r.appendChild(treeNode);
    var ul = nul('container', 'commits');
    renderIntoWith(ul, renderCommit, tree.commits);
    r.appendChild(ul);
    return r;
}

function dayText (day) {
    return day.date + ' &ndash; ' + day.test_count + ' tests of '
                + day.build_count + ' builds on ' + day.tree_count + ' trees';
}

function renderDay(day) {
    var r = nli('day');
    var outer = nd('item', 'day');
    day.tree_count = day.trees.length;
    outer.appendChild(
        nd('item-inner', 'day').setContent(dayText(day)));
    r.appendChild(outer);
    var ul = nul('container', 'trees');
    renderIntoWith(ul, renderTree, day.trees, true);
    r.appendChild(ul);
    return r;
}

function renderAll (data) {
    var r = nul('container', 'days');
    renderIntoWith(r, renderDay, data);
    r.appendChild('<div style="clear:both" />');

    r.all('.tree-expander').on(
        'mouseenter', function (e) {
            var me = e.target.ancestor('.cell');
            if (me.getStyle('width') == '75%') {
                e.target.all('.in-arrow').removeClass('invisible');
            } else {
                e.target.all('.out-arrow').removeClass('invisible');
            }
        }
    );
    r.all('.tree-expander').on(
        'mouseleave', function (e) {
            e.target.all('.arrow').addClass('invisible');
        }
    );
    r.all('.tree-expander').on(
        'click', function (e) {
            var me = e.target.ancestor('.cell');
            var all = me.ancestor('.container').get('children').filter('.cell:not(.dummy)');
            var expanded = me.getStyle('width') == '75%';
            me.all('.arrow').toggleClass('invisible');
            if (!expanded) {
                var w = (25 - 1*(all.size()-1))/(all.size() - 1);
                all.setStyle('width', w + '%');
                me.setStyle('width', '75%');
            } else {
                var w = (100 - 1*(all.size()-1))/(all.size());
                all.setStyle('width', w + '%');
            }
        }
    );
    return r;
}